SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Binding'!
SystemOrganization addCategory: #'Xenon-Core'!
SystemOrganization addCategory: #'Xenon-Core-Translators'!
SystemOrganization addCategory: #'Xenon-Core-Semantic'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Scope'!
SystemOrganization addCategory: #'Xenon-Core-Matching'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Exceptions'!

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/5/2012 15:47'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:
! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/19/2012 23:18'!
asXeType
	^ XeTypes default at: self
	! !

!String methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 20:57'!
asCLiteralValue
 	^ '"', self, '"'
	! !

!SmallInteger methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:39'!
asCLiteralValue
	^ self asString
	! !

Notification subclass: #XeUndeclaredVariableNotification
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeUndeclaredVariableNotification class methodsFor: 'signalling' stamp: 'BernardoContreras 4/14/2012 21:13'!
node: aVariableNode
	^ self new
		node: aVariableNode;
		signal: aVariableNode name , ' is undeclared'! !

!XeUndeclaredVariableNotification methodsFor: 'configuration' stamp: 'BernardoContreras 4/15/2012 01:57'!
defaultAction
	^ XeUndeclaredBinding node: self node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node
	^ node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node: aNode
	node := aNode! !

RBProgramNodeVisitor subclass: #XeFunctionPrototypeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translators'!

!XeFunctionPrototypeTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write function prototypes on a stream.
!

!XeFunctionPrototypeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/6/2012 21:06'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 00:51'!
acceptMethodNode: aMethodNode
	aMethodNode scope returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitArguments: aMethodNode arguments.
	self nextPut: $); nextPut: $;; cr.! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 00:52'!
acceptVariableNode: aVariableNode
	(aVariableNode scope lookupTypeFor: aVariableNode name) emitOn: stream.
	self space.
	self nextPutAll: aVariableNode name! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
cr
	stream cr! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPut: anObject
	stream nextPut: anObject! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
space
	stream space! !

!XeFunctionPrototypeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/6/2012 21:10'!
stream: aStream 
	stream := aStream! !

!XeFunctionPrototypeTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/8/2012 19:43'!
visitArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

RBProgramNodeVisitor subclass: #XeMethodTranslator
	instanceVariableNames: 'stream indentationLevel translationDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translators'!

!XeMethodTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write functions on a stream
!

!XeMethodTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/7/2012 02:16'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/7/2012 02:16'!
acceptLiteralNode: aLiteralNode
	self nextPutAll: (self cLiteralValueFor: aLiteralNode token)! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/13/2012 05:07'!
acceptMessageNode: aMessageNode
	(self translateBuiltinMessageFor: aMessageNode)
		ifTrue: [ ^ self ].
	(aMessageNode isCascaded not or: [ aMessageNode isFirstCascaded ])
		ifTrue: [ self visitNode: aMessageNode receiver ].
	aMessageNode isBinary
		ifTrue: [ 
			self space.
			self nextPutAll: aMessageNode selector.
			self space.
			aMessageNode arguments do: [ :each | self visitNode: each ] ].
	aMessageNode isKeyword
		ifTrue: [ 
			stream nextPutAll: aMessageNode cFunctionName.
			self nextPut: $(.
			aMessageNode arguments do: [ :each | self visitNode: each ] separatedBy: [ self nextPutAll: ', ' ].
			self nextPut: $) ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 00:51'!
acceptMethodNode: aMethodNode
	aMethodNode scope returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitMethodArguments: aMethodNode arguments.
	self
		nextPutAll: '){';
		cr.
	self incrementIndentation.
	self visitNode: aMethodNode body.
	self decrementIndentation.
	self
		nextPutIndentation;
		nextPut: $};
		cr! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 00:52'!
acceptReturnNode: aReturnNode
	aReturnNode scope returnType = #void asXeType
		ifTrue: [ 
			self visitNode: aReturnNode value.
			self endsWithClosingBracket
				ifFalse: [ self nextPut: $; ].
			self cr.
			self
				nextPutIndentation;
				nextPutAll: 'return' ]
		ifFalse: [ 
			self
				nextPutAll: 'return';
				space.
			self visitNode: aReturnNode value ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/13/2012 04:35'!
acceptSequenceNode: aSequenceNode
	"self visitArguments: aSequenceNode temporaries."

	aSequenceNode statements
		do: [ :each | 
			self nextPutIndentation.
			self visitNode: each.
			self endsWithClosingBracket
				ifFalse: [ self nextPut: $; ].
			self cr ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 01:52'!
acceptVariableNode: aVariableNode
	aVariableNode xeVariableBinding isArgumentBinding
		ifTrue: [ 
			aVariableNode parent isMethod
				ifTrue: [ 
					(aVariableNode scope lookupTypeFor: aVariableNode name) emitOn: stream.
					self space ] ].
	aVariableNode xeVariableBinding isSelfBinding
		ifFalse: [ self nextPutAll: aVariableNode name ]! !

!XeMethodTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/11/2012 04:34'!
cLiteralValueFor: aRBLiteralToken 
	^ aRBLiteralToken value asCLiteralValue! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
cr
	stream cr! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/13/2012 05:04'!
endsWithClosingBracket
	"Answer true if the stream ends in a $} character."

	| ch pos |
	(pos := stream position) > 0
		ifTrue: [ 
			stream position: pos - 1.
			ch := stream next.
			^ ch = $} ].
	^ false! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeMethodTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/12/2012 23:36'!
initialize
	| pairs |
	super initialize.
	indentationLevel := 0.
	translationDict := Dictionary new: 200.
	pairs := #(#ifTrue: #translateIfTrueFor:).
	1 to: pairs size by: 2 do: [ :i | translationDict at: (pairs at: i) put: (pairs at: i + 1) ]! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPut: anObject
	stream nextPut: anObject! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPutIndentation
	stream tab: indentationLevel ! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
space
	stream space! !

!XeMethodTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:16'!
stream: aStream 
	stream := aStream! !

!XeMethodTranslator methodsFor: 'private utilities' stamp: 'BernardoContreras 4/13/2012 00:15'!
translateBuiltinMessageFor: aMessageNode
	"If the given selector is in the translation dictionary, translate it into a target code construct and return true. Otherwise, do nothing and return false."

	| action |
	action := translationDict at: aMessageNode selector ifAbsent: [ ^ false ].
	self perform: action with: aMessageNode.
	^ true! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 4/13/2012 04:27'!
translateIfTrueFor: aMessageNode
	self nextPutAll: 'if ('.
	self visitNode: aMessageNode receiver.
	self
		nextPutAll: '){';
		cr.
	self incrementIndentation.
	self visitArguments: aMessageNode arguments.
	self decrementIndentation.
	self
		nextPutIndentation;
		nextPut: $}! !

!XeMethodTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/12/2012 20:14'!
visitMethodArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

RBProgramNodeVisitor subclass: #XeSemanticAnnotator
	instanceVariableNames: 'scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic'!

!XeSemanticAnnotator methodsFor: 'visitor-dispatching' stamp: 'BernardoContreras 4/14/2012 20:45'!
acceptBlockNode: aNode
	self scope: aNode with: XeBlockScope during: [ super acceptBlockNode: aNode ]! !

!XeSemanticAnnotator methodsFor: 'visitor-dispatching' stamp: 'BernardoContreras 4/14/2012 20:45'!
acceptMethodNode: aNode 
	self scope: aNode with: XeMethodScope during: [ super acceptMethodNode: aNode  ]! !

!XeSemanticAnnotator methodsFor: 'visitor-dispatching' stamp: 'BernardoContreras 4/15/2012 01:01'!
acceptPragmaNode: aPragmaNode
	aPragmaNode selector == #returnType:
		ifTrue: [ 
			aPragmaNode scope hasReturnType
				ifTrue: [ 
					XeTooManyReturnTypesError
						signalForSelector: aPragmaNode parent selector
						returnTypes:
							{(aPragmaNode scope returnType).
							(aPragmaNode arguments first token value)} ]
				ifFalse: [ aPragmaNode scope add: (XeReturnTypeBinding returnType: aPragmaNode arguments first token value) ] ].
	aPragmaNode selector == #var:type:
		ifTrue: [ 
			aPragmaNode scope
				add:
					(XeTypeBinding for: aPragmaNode arguments first token value type: aPragmaNode arguments second token value asXeType) ]! !

!XeSemanticAnnotator methodsFor: 'visitor-dispatching' stamp: 'BernardoContreras 4/14/2012 21:12'!
acceptSequenceNode: aNode
	aNode temporaries
		do: [ :each | scope add: (XeTemporaryBinding node: each) ].
	aNode statements
		do: [ :each | self visitNode: each ]! !

!XeSemanticAnnotator methodsFor: 'visitor-dispatching' stamp: 'BernardoContreras 4/15/2012 01:52'!
acceptVariableNode: aNode
	| binding |
	binding := scope
		lookup: aNode name
		ifAbsent: [ self undeclaredVariable: aNode ].
	aNode propertyAt: #xeVariableBinding put: binding.
	binding addAccessor: aNode.
	aNode isUsed
		ifTrue: [ binding addReader: aNode ].
	aNode isWrite
		ifTrue: [ binding addWriter: aNode ]! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:24'!
scope: aNode with: aClass during: aBlock
	scope := aClass owner: scope node: aNode.
	^ aBlock ensure: [ scope := scope owner ]! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode
	self visitNode: aProgramNode methodNode! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode scope: aLexicalScope
	scope := aLexicalScope.
	self start: aProgramNode! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 4/15/2012 00:53'!
undeclaredVariable: aNode
	^ aNode scope add: (XeUndeclaredVariableNotification node: aNode)! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 21:13'!
visitArgument: aNode
	scope add: (XeArgumentBinding node: aNode)! !

!True methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:37'!
asCLiteralValue
	^ '1'! !

!RBMessageNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/9/2012 03:59'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:! !

!False methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 19:50'!
asCLiteralValue
	^ '0'! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:50'!
hasXeVariableBinding
	^ self hasProperty: #xeVariableBinding! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:51'!
xeVariableBinding
	^ self propertyAt: #xeVariableBinding ifAbsent: [ self xeSemanticAnnotationMissing ]! !

Error subclass: #XeSemanticAnnotationMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeSemanticAnnotationMissing methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:13'!
isResumable
	^ true! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/25/2012 02:51'!
signalForSelector: aSelectorName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , '. actual types: ' , anArray asString.
	^ self signal: message! !

Error subclass: #XeTypeNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeTypeNotFoundError commentStamp: 'BernardoContreras 3/19/2012 23:49' prior: 0!
When a type is not found.
!

!XeTypeNotFoundError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/19/2012 23:43'!
signalFor: aSymbol 

	^ self signal: 'Couldn''t find type: ' , aSymbol.! !

!UndefinedObject methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 20:20'!
asCLiteralValue
	^ 'null'
	! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 00:46'!
scope
	^ self propertyAt: #scope ifAbsent: [ 
		self parent isNil
			ifFalse: [ self parent scope ]
			ifTrue: [ self xeSemanticAnnotationMissing ] ]! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:33'!
xeAnnotateInClass: aBehavior
	XeSemanticAnnotator new
		start: self
		scope: (XeVariableScope owner: (XeLiteralScope owner: XeRootScope new class: aBehavior) class: aBehavior)! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 00:46'!
xeSemanticAnnotationMissing
	XeSemanticAnnotationMissing signal: 'Semantic annotation missing, please use #annotateInClass: to annotate the AST'! !

!Object methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:36'!
asCLiteralValue
	self subclassResponsibility! !

Object subclass: #XeCodeGenerator
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeCodeGenerator commentStamp: 'BernardoContreras 3/19/2012 22:14' prior: 0!
* Constants are translated only if they are binded in a method.
!

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/15/2012 01:34'!
addClass: aClass
	aClass
		methodsDo: [ :method | methods add: ((self parserClass parseMethod: method getSource) xeAnnotateInClass: aClass) ]! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/15/2012 01:26'!
codeString
	| stream |
	stream := ReadWriteStream on: (String new: 1000).
	self sortMethods.
	"self annotate."
	self translateOn: stream.
	^ stream contents! !

!XeCodeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/6/2012 19:28'!
initialize
	super initialize.
	methods := OrderedCollection new.! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 06:58'!
sortMethods
	methods sort: [ :a :b | a selector caseSensitiveLessOrEqual: b selector ]! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:17'!
translateOn: aStream
	| translator |
	translator := self translatorClass newFor: aStream.
	translator translate: methods! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !

Object subclass: #XeLexicalScope
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLexicalScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:27'!
new
	^ self basicNew initialize! !

!XeLexicalScope methodsFor: 'adding' stamp: 'BernardoContreras 4/14/2012 20:27'!
add: aVariableBinding
	"Add aVariableBinding to the receving scope."

	^ bindings at: aVariableBinding name put: (aVariableBinding setScope: self)! !

!XeLexicalScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:27'!
basicBindingOf: aString
	^ nil! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
bindingOf: aString
	"Answer the local binding of aString or nil."
	
	^ bindings at: aString ifAbsent: [
		| binding |
		binding := (self basicBindingOf: aString) 
			ifNil: [ ^ nil ].
		self add: binding ]! !

!XeLexicalScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:27'!
hasReturnType
	self lookup: 'returnType' ifAbsent: [ ^ false ].
	^ true! !

!XeLexicalScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:46'!
initialize
	bindings := XeSmallDictionary new! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isBlockScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isLiteralScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isMethodScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isRootScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isVariableScope
	^ false! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString
	"Lookup the variable aString in the receiving scope, throw an error if not found."

	^ self lookup: aString ifAbsent: [ self error: 'No binding for ' , aString printString , ' found.' ]! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString ifAbsent: aBlock
	"Lookup the variable aString in the receiving scope, evaluate aBlock if not found."

	self subclassResponsibility! !

!XeLexicalScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookupTypeFor: aVariableName
	^ (self lookup: aVariableName , 'Type' ifAbsent: [ #default ]) asXeType! !

!XeLexicalScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:27'!
returnType
	^ (self lookup: 'returnType' ifAbsent: [ #default ]) asXeType! !

XeLexicalScope subclass: #XeOwnedScope
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

XeOwnedScope subclass: #XeClassScope
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeClassScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:30'!
owner: aLexicalScope class: aBehavior
	^ (self owner: aLexicalScope) setClass: aBehavior! !

!XeClassScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:30'!
setClass: aBehavior
	class := aBehavior! !

!XeClassScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:30'!
theClass
	^ class! !

XeClassScope subclass: #XeLiteralScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLiteralScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 21:10'!
basicBindingOf: aString
	^ (class bindingOf: aString) ifNotNil: [ :binding | XeLiteralBinding binding: binding ]! !

!XeLiteralScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:31'!
isLiteralScope
	^ true! !

XeClassScope subclass: #XeVariableScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeVariableScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:37'!
isVariableScope
	^ true! !

!XeVariableScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 21:11'!
setClass: aClass
	super setClass: aClass.
	aClass allInstVarNames 
		keysAndValuesDo: [ :index :name | self add: (XeInstanceBinding name: name index: index) ]! !

XeOwnedScope subclass: #XeNodedScope
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

XeNodedScope subclass: #XeBlockScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeBlockScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:39'!
isBlockScope
	^ true! !

XeNodedScope subclass: #XeMethodScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeMethodScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:40'!
isMethodScope
	^ true! !

!XeNodedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:38'!
owner: aLexicalScope node: aProgramNode
	^ (self owner: aLexicalScope) setNode: aProgramNode! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:38'!
node
	"Answer the program node that defines this scope."
	
	^ node! !

!XeNodedScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/15/2012 00:53'!
setNode: aProgramNode
	node := aProgramNode.
	node propertyAt: #scope put: self! !

!XeOwnedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner: aLexicalScope
	^ self new setOwner: aLexicalScope! !

!XeOwnedScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:28'!
lookup: aString ifAbsent: aBlock
	^ (self bindingOf: aString) ifNil: [ owner lookup: aString ifAbsent: aBlock ]! !

!XeOwnedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner
	"Answer the owning scope."

	^ owner! !

!XeOwnedScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:28'!
setOwner: aLexicalScope
	owner := aLexicalScope! !

XeLexicalScope subclass: #XeRootScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeRootScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 21:11'!
initialize
	super initialize.
	self add: XeSelfBinding new.
	self add: XeSuperBinding new.
	self add: XeContextBinding new! !

!XeRootScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:42'!
isRootScope
	^ true! !

!XeRootScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:42'!
lookup: aString ifAbsent: aBlock
	^ bindings at: aString ifAbsent: aBlock! !

Object subclass: #XeSmallDictionary
	instanceVariableNames: 'keys values tally'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Matching'!

!XeSmallDictionary commentStamp: 'BernardoContreras 4/15/2012 01:36' prior: 0!
It was stolen from the Refactoring Browser.
RBSmallDictionary is a special dictionary optimized for small collections. In addition to the normal dictionary protocol, it also supports an #empty message which "empties" the collection but may hang on to the original elements (so it could collect garbage). Without #empty we would either need to create a new dictionary or explicitly remove everything from the dictionary. Both of these take more time and #empty.

Instance Variables:
array <Array of: Object> array of keys (we don't use Associations for our key value pairs)
tally <Integer> the size of the dictionary
values <Array of: Object> array of our values!

!XeSmallDictionary class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:45'!
new
	^ self new: 2! !

!XeSmallDictionary class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:45'!
new: anInteger 
	^ self basicNew initialize: anInteger! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
at: aKey
	"Answer the value associated with aKey. Raise an exception, if no such key is defined."

	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
at: aKey ifAbsent: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ aBlock value ]! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
at: aKey ifAbsentPut: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined and store the return value."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ self privateAt: aKey put: aBlock value ]! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
at: aKey put: aValue
	"Set the value of aKey to be aValue."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index put: aValue ]
		ifTrue: [ self privateAt: aKey put: aValue ]! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
empty
	tally := 0! !

!XeSmallDictionary methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:45'!
errorKeyNotFound
	self error: 'Key not found'! !

!XeSmallDictionary methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:45'!
findIndexFor: aKey
	1 to: tally do: [ :index |
		(keys at: index) = aKey
			ifTrue: [ ^ index ] ].
	^ 0! !

!XeSmallDictionary methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:45'!
grow
	| newKeys newValues |
	newKeys := Array new: 2 * tally.
	newValues := Array new: 2 * tally.
	1 to: tally do: [ :index |
		newKeys at: index put: (keys at: index).
		newValues at: index put: (values at: index) ].
	keys := newKeys.
	values := newValues! !

!XeSmallDictionary methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:45'!
includesKey: aKey
	"Answer whether the receiver has a key equal to aKey."

	^ (self findIndexFor: aKey) ~= 0! !

!XeSmallDictionary methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:45'!
initialize: anInteger
	tally := 0.
	keys := Array new: anInteger.
	values := Array new: anInteger! !

!XeSmallDictionary methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:45'!
isEmpty
	^ tally = 0! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
keys
	^ keys copyFrom: 1 to: tally! !

!XeSmallDictionary methodsFor: 'enumerating' stamp: 'BernardoContreras 4/14/2012 20:45'!
keysAndValuesDo: aBlock
	1 to: tally do: [ :index | aBlock value: (keys at: index) value: (values at: index) ]! !

!XeSmallDictionary methodsFor: 'enumerating' stamp: 'BernardoContreras 4/14/2012 20:45'!
keysDo: aBlock
	1 to: tally do: [ :each | aBlock value: (keys at: each) ]! !

!XeSmallDictionary methodsFor: 'copying' stamp: 'BernardoContreras 4/14/2012 20:45'!
postCopy
	super postCopy.
	keys := keys copy.
	values := values copy! !

!XeSmallDictionary methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:45'!
privateAt: aKey put: aValue
	tally = keys size ifTrue: [ self grow ].
	keys at: (tally := tally + 1) put: aKey.
	^ values at: tally put: aValue! !

!XeSmallDictionary methodsFor: 'removing' stamp: 'BernardoContreras 4/14/2012 20:45'!
removeKey: aKey
	"Remove aKey from the receiver, raise an exception if the element is missing."

	^ self removeKey: aKey ifAbsent: [ self errorKeyNotFound ]! !

!XeSmallDictionary methodsFor: 'removing' stamp: 'BernardoContreras 4/14/2012 20:45'!
removeKey: aKey ifAbsent: aBlock
	"Remove aKey from the receiver, evaluate aBlock if the element is missing."

	| index value |
	index := self findIndexFor: aKey.
	index = 0 ifTrue: [ ^ aBlock value ].
	value := values at: index.
	index to: tally - 1 do: [ :i |
		keys at: i put: (keys at: i + 1).
		values at: i put: (values at: i + 1) ].
	keys at: tally put: nil.
	values at: tally put: nil.
	tally := tally - 1.
	^ value! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
size
	^ tally! !

!XeSmallDictionary methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:45'!
values
	^ values copyFrom: 1 to: tally! !

!XeSmallDictionary methodsFor: 'enumerating' stamp: 'BernardoContreras 4/14/2012 20:45'!
valuesDo: aBlock
	1 to: tally do: [ :index | aBlock value: (values at: index) ]! !

Object subclass: #XeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator commentStamp: 'BernardoContreras 4/5/2012 15:50' prior: 0!
To translate to C Code on a stream
!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 06:58'!
newFor: aStream
	" a new instance for the given stream"

	^ self new
		stream: aStream;
		yourself! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
functionPrototypeTranslatorClass
	^ XeFunctionPrototypeTranslator 
	! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
methodTranslatorClass
	^ XeMethodTranslator
	 
	! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 06:58'!
stream: aStream
	stream := aStream! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:36'!
translate: methods
	self translateFunctionPrototypesFor: methods.
	self translateMethodsFor: methods! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:34'!
translateFunctionPrototypesFor: methods
	| translator |
	stream
		nextPutAll: '/*** Function Prototypes ***/';
		cr.
	translator := self functionPrototypeTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:35'!
translateMethodsFor: methods
	| translator |
	translator := self methodTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

Object subclass: #XeType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

!XeType class methodsFor: 'instance creation' stamp: 'BernardoContreras 3/25/2012 03:55'!
name: aString 
	^ self new name: aString.! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 3/25/2012 03:57'!
emitOn: aStream
	"emit the string representation of this type on a stream"

	aStream nextPutAll: name! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:56'!
name: aString 
	name := aString! !

!XeType methodsFor: 'printing' stamp: 'BernardoContreras 4/13/2012 01:12'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' named: ';
		nextPutAll: name! !

Object subclass: #XeTypes
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes commentStamp: 'BernardoContreras 3/20/2012 00:19' prior: 0!
Hold all defined types!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes class methodsFor: 'singleton' stamp: 'BernardoContreras 3/19/2012 23:57'!
default
	^ default ifNil: [ default := self new ]! !

!XeTypes class methodsFor: 'class initialization' stamp: 'BernardoContreras 3/20/2012 00:04'!
initialize
	default := nil! !

!XeTypes class methodsFor: 'cleanup' stamp: 'BernardoContreras 3/19/2012 23:58'!
reset
	"XeTypes reset"

	default := nil! !

!XeTypes methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:43'!
at: aSymbol
	^ types at: aSymbol ifAbsent: [ XeTypeNotFoundError signalFor: aSymbol ]! !

!XeTypes methodsFor: 'initialize-release' stamp: 'BernardoContreras 3/25/2012 03:54'!
initialize
	super initialize.
	types := Dictionary new.
	types at: #int put: (XeType name: 'int').
	types at: #void put: (XeType name: 'void').
	types at: #default put: (XeType name: 'sqInt')! !

Object subclass: #XeVariableBinding
	instanceVariableNames: 'scope accessors readers writers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

XeVariableBinding subclass: #XeInstanceBinding
	instanceVariableNames: 'name index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeInstanceBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:54'!
name: aString index: anInteger
	^ self new initializeName: aString index: anInteger! !

!XeInstanceBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:54'!
index
	^ index! !

!XeInstanceBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:54'!
initializeName: aString index: anInteger
	name := aString.
	index := anInteger! !

!XeInstanceBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:54'!
isInstanceBinding
	^ true! !

!XeInstanceBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:54'!
name
	^ name! !

XeVariableBinding subclass: #XeLiteralBinding
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeLiteralBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding: aBinding
	^ self new initializeBinding: aBinding! !

!XeLiteralBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding
	^ binding! !

!XeLiteralBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:55'!
initializeBinding: aBinding
	binding := aBinding! !

!XeLiteralBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:55'!
isLiteralBinding
	^ true! !

!XeLiteralBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:55'!
name
	^ binding key asString! !

XeVariableBinding subclass: #XeLocalBinding
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

XeLocalBinding subclass: #XeArgumentBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeArgumentBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isArgumentBinding
	^ true! !

!XeArgumentBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:57'!
isReadonly
	^ true! !

!XeLocalBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:56'!
node: aNode
	^ self new setNode: aNode! !

!XeLocalBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:56'!
name
	^ node name! !

!XeLocalBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:56'!
node
	"Answer the declaring or defining node."
	
	^ node! !

!XeLocalBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/15/2012 01:52'!
setNode: aNode
	node := aNode.
	node propertyAt: #xeVariableBinding put: self! !

XeLocalBinding subclass: #XeTemporaryBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeTemporaryBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isTemporaryBinding
	^ true! !

XeLocalBinding subclass: #XeUndeclaredBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeUndeclaredBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:01'!
isUndeclaredBinding
	^ true! !

XeVariableBinding subclass: #XeReturnTypeBinding
	instanceVariableNames: 'returnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeReturnTypeBinding commentStamp: 'BernardoContreras 4/14/2012 20:49' prior: 0!
To bind the return type of  a method
!

!XeReturnTypeBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/13/2012 01:23'!
returnType: typeName
	^ self new
		returnType: typeName;
		yourself! !

!XeReturnTypeBinding methodsFor: 'converting' stamp: 'BernardoContreras 4/13/2012 02:27'!
asXeType
	^ returnType asXeType
	! !

!XeReturnTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 02:12'!
name
	"Answer the name of the variable."

	^ 'returnType'! !

!XeReturnTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 01:24'!
returnType: typeName
 	returnType := typeName! !

XeVariableBinding subclass: #XeSpecialBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

XeSpecialBinding subclass: #XeContextBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeContextBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isContextBinding
	^ true! !

!XeContextBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'thisContext'! !

XeSpecialBinding subclass: #XeSelfBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSelfBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSelfBinding
	^ true! !

!XeSelfBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'self'! !

!XeSpecialBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:02'!
isReadonly
	^ true! !

XeSpecialBinding subclass: #XeSuperBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSuperBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSuperBinding
	^ true! !

!XeSuperBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'super'! !

XeVariableBinding subclass: #XeTypeBinding
	instanceVariableNames: 'variableName type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeTypeBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/13/2012 23:26'!
for: aVariableName type: type 
	^ self new variableName: aVariableName; type: type; yourself.! !

!XeTypeBinding methodsFor: 'converting' stamp: 'BernardoContreras 4/13/2012 21:52'!
asXeType
	^ type! !

!XeTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 21:44'!
name
	"Answer the name of the variable."

	^ variableName , 'Type'! !

!XeTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 21:43'!
type: aType 
	type := aType! !

!XeTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 21:47'!
variableName: aVariableName 
	variableName := aVariableName ! !

!XeVariableBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:49'!
new
	^ self basicNew initialize! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
accessors
	"Answer the nodes that access the receiver."
	
	^ accessors! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addAccessor: aProgramNode
	accessors := accessors copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addReader: aProgramNode
	readers := readers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addWriter: aProgramNode
	writers := writers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:49'!
initialize
	accessors := readers := writers := #()! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isAccessed
	"Answer true if the receiving binding is accessed."
	
	^ self accessors notEmpty! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isArgumentBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isContextBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isInstanceBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isLiteralBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isRead
	"Answer true if the receiving binding is read."
	
	^ self readers notEmpty! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isReadonly
	"Answer if the receiving binding is readonly."

	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSelfBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isShadowing
	"Answer true if the receiving shadows another variable in a parent scope."

	self scope isRootScope
		ifTrue: [ ^ false ].
	self scope owner
		lookup: self name
		ifAbsent: [ ^ false ].
	^ true! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSuperBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isTemporaryBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isUndeclaredBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isWritten
	"Answer true if the receiving binding is written."
	
	^ self writers notEmpty! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
name
	"Answer the name of the variable."
	
	self subclassResponsibility! !

!XeVariableBinding methodsFor: 'printing' stamp: 'BernardoContreras 4/14/2012 20:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
readers
	"Answer the nodes that read from the receiver."
	
	^ readers! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
scope
	"Answer the owning scope."
	
	^ scope! !

!XeVariableBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:49'!
setScope: aLexicalScope
	scope := aLexicalScope! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
writers
	"Answer the nodes that write to the receiver."
	
	^ writers! !

!RBLexicalScope methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/13/2012 02:35'!
hasReturnType
	self lookup: 'returnType' ifAbsent: [ ^ false ].
	^ true! !

!RBLexicalScope methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/13/2012 21:51'!
lookupTypeFor: aVariableName
	^ (self lookup: aVariableName , 'Type' ifAbsent: [ #default ]) asXeType! !

!RBLexicalScope methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/14/2012 00:20'!
returnType
	^ (self lookup: 'returnType' ifAbsent: [ #default ]) asXeType! !
XeTypes initialize!
